#!/usr/local/gnu/bin/bash

if [ $# -lt 1 ]
then
	echo "usage: lsqrs.sh [-c] filename"
	echo "ex   : lsqrs.sh -c c1       	    (doesn't convert file c1)"
	echo "ex   : lsqrs.sh    sng_dist.500.0.050 (calls lsqr_dist)"
	exit
fi

distfile="/tmp/d.dist"
infile="/tmp/d.input"
outfile="/tmp/d.output"

if [ -f $distfile ]
then
	rm $distfile
fi

if [ -f $outfile ]
then
	rm $outfile
fi

if [ -f $infile ]
then
	rm $infile
fi

if [ $1 = "-c" ]
then
	cp $2 $distfile
else
	lsqr_dist $1 > $distfile
fi

#echo "with(linalg);" > $infile
2d_maple_array -v lines=100 -v array_name=ddd -v field1=1 -v field2=2 $distfile >> $infile

#echo "myreg(ddd, y=[x]);">> $infile

#echo "regression(ddd, y = a + b * (1/sqrt(x)));" >> $infile

#transform x and y first, then use simple regression instead
#to make error calculations easier

echo "b := myreg(ddd, y/sqrt(y * (1-y)) = a/sqrt(y*(1-y)) + b * 1/(sqrt(x)*sqrt(y*(1-y))));">> $infile
echo "eval_fit(ddd,b);" >> $infile


#echo "regression(ddd, ln(y/(1-y))/(1000*(y * (1-y))) = 
#a/(1000*(y * (1-y))) + 
#b * x/(1000*(y * (1-y))));">> $infile

#maple.old -q -f < $infile > $outfile
maple -q -f < $infile > $outfile

set - `tail -2 $outfile | map_coefs.awk`


echo "$1  $2  $3  $4"
#tail -2 $outfile


rm $distfile
#rm $outfile
#rm $infile

#old way to find rsquared
#------------------------
#rm $outfile
#rm $infile

#echo "with(linalg);" > $infile
#2d_maple_array -v lines=100 -v array_name=ddd -v field1=1 -v field2=2 $distfile >> $infile
#echo "ddd := stats[removekey](ddd);" >> $infile
#echo "d := stats[putkey](concat(delcols(ddd, 1..1), delcols(map(x->$1 + $2 * (1/sqrt(x)),ddd), 2..2)), [y,z]);" >> $infile
#echo " Rsquared(d, y, z);" >> $infile
#
#maple.old -q -f < $infile > $outfile
