CC = gcc
FLAGS = -ggdb -O -DBUCKET -ansi -pedantic -Wall
FLAGS1 = $(FLAGS) -c
CLIB = -lc -ll -lm

OBJECTS = read_graph.o output_rao.o output_gw.o output_chaco.o extra_files.o find_prob.o sng_dist.o use_config.o ctab_100_010.o ctab_500_050_G.o ctab_500_240_G.o clusters.o get_stats_geom.o get_stats_rand.o var_tab4.o var_tab3.o var_tab2.o variance_stats.o var_tab.o data_sets.o regular.o kd_tab.o ng_uptab.o geom.o queue.o bfs.o nongreedy_stats.o output_gp.o greedy_history.o lex.yy.o kl.o backtrack.o etime.o adjlist.o postproc.o sort.o read.o textplot.o args.o bucket.o local_opt.o push_history.o bk.o

$(BINDIR)/bk : $(OBJECTS) part.h;
	$(CC)  $(FLAGS) -o $(BINDIR)/bk $(OBJECTS) $(CLIB)

read_graph.o : read_graph.c part.h read_graph.h;
	$(CC) $(CFLAGS1)     read_graph.c 

output_rao.o : output_rao.c part.h;
	$(CC) $(CFLAGS1)     output_rao.c 

output_chaco.o : output_chaco.c part.h;
	$(CC) $(FLAGS1)     output_chaco.c 

extra_files.o : extra_files.c part.h;
	$(CC) $(FLAGS1)     extra_files.c 

sng_dist.o : sng_dist.c part.h;
	$(CC) $(FLAGS1)     sng_dist.c 

find_prob.o : find_prob.c part.h;
	$(CC) $(FLAGS1)     find_prob.c 

ctab_100_010_G.o : ctab_100_010_G.c part.h;
	$(CC) $(FLAGS1)     ctab_100_010_G.c 

ctab_500_050_G.o : ctab_500_050_G.c part.h;
	$(CC) $(FLAGS1)     ctab_500_050_G.c 

ctab_500_240_G.o : ctab_500_240_G.c part.h;
	$(CC) $(FLAGS1)     ctab_500_240_G.c 

use_config.o : use_config.c part.h;
	$(CC) $(FLAGS1)     use_config.c 

clusters.o : clusters.c part.h data_sets.h;
	$(CC) $(FLAGS1)     clusters.c 

get_stats_rand.o : get_stats_rand.c part.h data_sets.h;
	$(CC) $(FLAGS1)     get_stats_rand.c 

get_stats_geom.o : get_stats_geom.c part.h data_sets.h;
	$(CC) $(FLAGS1)     get_stats_geom.c 

var_tab4.o : var_tab4.c part.h data_sets.h;
	$(CC) $(FLAGS1)     var_tab4.c 

var_tab3.o : var_tab3.c part.h data_sets.h;
	$(CC) $(FLAGS1)     var_tab3.c 

var_tab2.o : var_tab2.c part.h data_sets.h;
	$(CC) $(FLAGS1)     var_tab2.c 

var_tab.o : var_tab.c part.h data_sets.h;
	$(CC) $(FLAGS1)     var_tab.c 

data_sets.o : data_sets.c part.h data_sets.h;
	$(CC) $(FLAGS1)     data_sets.c 

variance_stats.o : variance_stats.c part.h data_sets.h;
	$(CC) $(FLAGS1)     variance_stats.c 

regular.o : regular.c part.h ;
	$(CC) $(FLAGS1)     regular.c

kd_tab.o : kd_tab.c part.h ;
	$(CC) $(FLAGS1)     kd_tab.c

ng_uptab.o : ng_uptab.c part.h ;
	$(CC) $(FLAGS1)     ng_uptab.c

geom.o : geom.c part.h ;
	$(CC) $(FLAGS1)     geom.c 

tab.o : tab.c part.h ;
	$(CC) $(FLAGS1)     tab.c 

queue.o : queue.c part.h ;
	$(CC) $(FLAGS1)     queue.c 

bfs.o : bfs.c part.h ;
	$(CC) $(FLAGS1)     bfs.c 

nongreedy_stats.o : nongreedy_stats.c part.h ;
	$(CC) $(FLAGS1)     nongreedy_stats.c 

output_gp.o : output_gp.c part.h ;
	$(CC) $(FLAGS1)     output_gp.c 

greedy_history.o : greedy_history.c part.h
	$(CC) $(FLAGS1)	greedy_history.c 

push_history.o : push_history.c part.h
	$(CC) $(FLAGS1)	push_history.c 

lex.yy.c : lex.l part.h;
	lex lex.l

lex.yy.o : lex.l lex.yy.c part.h;
	$(CC) $(FLAGS1)    lex.yy.c 

local_opt.o : local_opt.c part.h;
	$(CC) $(FLAGS1)    local_opt.c 

etime.o : etime.c part.h ;
	$(CC) $(FLAGS1)    etime.c 

adjlist.o : adjlist.c part.h ;
	$(CC) $(FLAGS1)    adjlist.c 

postproc.o : postproc.c part.h;
	$(CC) $(FLAGS1)    postproc.c 

sort.o : sort.c part.h;
	$(CC) $(FLAGS1)    sort.c 

textplot.o : textplot.c part.h;
	$(CC) $(FLAGS1)    textplot.c 

read.o : read.c part.h;
	$(CC) $(FLAGS1)    read.c 

args.o : args.c part.h;
	$(CC) $(FLAGS1)    args.c 

backtrack.o : backtrack.c backtrack.h part.h;
	$(CC) $(FLAGS1)    backtrack.c 

bk.o : bk.c backtrack.h part.h;
	$(CC) $(FLAGS1)    bk.c 

kl.o : kl.c backtrack.h part.h;
	$(CC) $(FLAGS1)    kl.c 

bucket.o : bucket.c part.h
	$(CC) $(FLAGS1)    bucket.c 
