/***********************************************************/
/*                  Graph Paritioning                      */
/*                       evalng.c                          */
/*                                                         */
/*                Author:  James P. Fox                    */
/*                Advisor: Mark Goldberg                   */
/*                                                         */
/*                    Masters Project                      */
/*            Rensselaer Polytechnic Institute             */
/*                  Summer, Fall, 1990                     */
/***********************************************************/
/*     This module provides the routines to handle the     */
/*  tuning of the near-greedy algorithm.  The routine      */
/*  "evaluate_non_greedy" is used to determine if a non-   */
/*  greedy step should be allowed at a particular point.   */
/*  It returns "TRUE" if the non-greedy step is to be      */
/*  allowed.                                               */
/***********************************************************/

#include "part.h"

int num_degree_nongreedy;

/***********************************************************/
/*****  check to see if non-greedy step is allowed   *******/
/***********************************************************/
int evaluate_non_greedy(x,y)
int x,y;
{  
   /** x is the current vertex being processed, relative to **/
   /**      the reordering being used.                      **/
   /** y is the "degree of non-greedyness" of this vertex   **/
   
   /**  This information, along with golbal information     **/
   /**     maintained in the main program can be used to    **/
   /**     tune this greedy algorithm.                      **/

   /**  currently this routine allows NO non-greedy steps   **/
   return(FALSE);
 }

/************************************************************/
/************   initialize near-greedy routines   ***********/
/************************************************************/
void init_eval_non_greedy()
{  /**  This global variable tells the system how many levels  **/
   /**    of non-greedyness to total.  Any degree of non-      **/
   /**    greedyness greater than this is considered equal to  **/
   /**    this value.                                          **/
   num_degree_nongreedy = 3;
}
