#include<stdio.h>
#include <math.h>
#include "part.h"

extern int num;
extern int num_graphs;
extern int Geometric_Graphs;
extern double prob;

extern FILE *outfile;

extern NG_DIST Nongreedy_Distribution[];
extern char *getenv();

FILE *Sng_Distfile;
FILE *NG_Upfile;

int old_graphs;

int octoint(char *oct_val)
/**************************************************************/
/** octoint()	: 	shouldn't be necessary, but scanf %o **/
/**			didn't work			     **/
/**************************************************************/
{
	int result=0;
	for (; *oct_val; result=result*8 + (*oct_val++ - '0'));
	return result;
}

/************************************************************************/
/** The following is  used in the context of a vertex placement.  For  **/
/** the i'th placement, keep the following stats as running totals over**/
/** all graphs processed so far:  <ng_up_g>:  for every time  step i   **/
/** was greedy, count the number of nongreedy upneighbors. ng_up_g is  **/
/** the total over all graphs. <up_g>: similar for ALL steps, not just **/
/** greedy steps.    <ng_up_n>, <up_n> similar, consider nongreedy steps*/
/************************************************************************/
UP_INFO NG_Up_Array[MAX_VERTS];
/************************************************************************/

void init_extra_file_info()
{
	extern int Output_Sng_Distfile;
	extern int Output_Configuration_Table;
	extern int *NG_Index_Array;
	extern int NG_Index_Array_Count;
	extern int NG_Upflag;
	int i,m;

	if (Output_Configuration_Table) {
		NG_Index_Array = (int *) calloc(NG_INDEX_SIZE, sizeof(int));
		NG_Index_Array_Count = 0;
	}

	if (Output_Sng_Distfile) {
        	for (i=0;i<MAX_VERTS;i++) {
			for (m=0; m<SIZE_INTERVAL_ARRAY; m++) {
               			Nongreedy_Distribution[i].tot[m] = 0;
               			Nongreedy_Distribution[i].num_ng[m] = 0;
			}
	   	}
	} 
	if (NG_Upflag) {
        	for (i=0;i<MAX_VERTS;i++) {
               		NG_Up_Array[i].times_ng = 0;
               		NG_Up_Array[i].ng_up_g = 0;
               		NG_Up_Array[i].up_g = 0;
               		NG_Up_Array[i].ng_up_n = 0;
               		NG_Up_Array[i].up_n = 0;
               		NG_Up_Array[i].pct_ng_up_g = 0.0;
               		NG_Up_Array[i].pct_ng_up_n = 0.0;
	   	}
	}
        old_graphs = 0;
}


FILE *read_sng_file()
{
	extern int Output_Configuration_Table;
	extern int Simulated_Annealing;
	extern int alg_type;
	extern int Up_NG_Intervals;
	extern int Abs_Diff_Intervals;
	extern int NG_10_Intervals;
	extern int Regular_Graphs;
	extern int Reg_Degree;
	extern int Reg_Degree2;
	extern int Increasing_Density_Experiments;
	extern int Increasing_Size_Experiments;
	extern int Unbalanced_Regular_Graphs;
	extern int Unbalanced_Random_Graphs;
	extern int *NG_Index_Array;
	extern int NG_Index_Array_Count;
	extern double prob2;
	int i,j, m;
	char path[80], fname[80], pr[30], *home;
	FILE *fp;

	home=(char *)malloc(80);
	/*******************************************************************/
	/** for this code to work, V must be a multiple of 100		  **/
	/*******************************************************************/
	old_graphs = 0;
	if (Regular_Graphs) {
		sprintf(pr, "%d", Reg_Degree);
	} else if (Unbalanced_Regular_Graphs) {
		sprintf(pr, "%d.%d", Reg_Degree, Reg_Degree2);
	} else if (Unbalanced_Random_Graphs) {
		sprintf(pr, "%.3f.%.3f", prob, prob2);
	} else if (Geometric_Graphs) {
		sprintf(pr, "%.3f.G", prob);
	} else
		sprintf(pr, "%.3f", prob);
	home = getenv("HOME");
	if (alg_type == BACKTRACKING) 
		sprintf(path,"%s/greedy/path_distributions",home);
	else {
		 if (Simulated_Annealing)
			sprintf(path,"%s/greedy/sa_distributions", home);
		 else if (Increasing_Density_Experiments)
			sprintf(path,"%s/greedy/j_distributions/incr_density",
								home);
		 else if (Increasing_Size_Experiments)
			sprintf(path,"%s/greedy/j_distributions/incr_size",
								home);
		 else if (Output_Configuration_Table)
			sprintf(path,"%s/greedy/j_distributions/config",home);
		 else
			sprintf(path,"%s/greedy/j_distributions",home);
	}
	if (NUM_INTERVALS > 1) {
	   if (Up_NG_Intervals)
	       sprintf(fname,"%s/sng_dist.k%d.%d.%s",path,NUM_INTERVALS,num,pr);
	   else if (Abs_Diff_Intervals)
	       sprintf(fname,"%s/sng_dist.a%d.%d.%s",path,NUM_INTERVALS,num,pr);
	   else if (NG_10_Intervals)
	       sprintf(fname,"%s/sng_dist.t%d.%d.%s",path,NUM_INTERVALS,num,pr);
	} else
	       sprintf(fname,"%s/sng_dist.%d.%s",path,num,pr);
	if ((fp = fopen(fname, "r+")) != NULL) {
		fscanf(fp, "%d", &old_graphs);
		for (i=0; i<num; i++) {
			fscanf(fp, "%d ", &j);
			for (m=0; m<SIZE_INTERVAL_ARRAY; m++) {
				fscanf(fp, "%d %d",  
				&Nongreedy_Distribution[i].num_ng[m],
				&Nongreedy_Distribution[i].tot[m]);
			}
		}
		if (Output_Configuration_Table) {
			char str[81];
			int i, freq;

			fscanf(fp,"%*s%*s%*s%d", &NG_Index_Array_Count);
			for (i=0; i<NG_Index_Array_Count; i++) {
				fscanf(fp,"%s %d", str, &freq);
				NG_Index_Array[octoint(str)] = freq;
			}
		}
	} else if ((fp = fopen(fname, "w")) == NULL) 
		fprintf(outfile, "Error in sng_dist file\n"), exit(23);
	rewind(fp);
	return(fp);
}

void write_sng_file(int num_v)
/******************************************************************************/
/** write_sng_file()	The sng_distfile is opened for updating once at	     **/
/**			the beginning of main().  Once open, the number	     **/
/**			of old graphs and the old distributions are read     **/
/**			As new graphs are processed, the file is periodically**/
/**			written out in case the machine dies during a very   **/
/**			long run.  Each time the distribution information is **/
/**			written, a new distribution table (to be put in      **/
/**			tab.c) is written out also.  The file is named:	     **/
/**			sng_dist.<num>.<prob> and located in ~/research      **/
/******************************************************************************/
{
	extern int Output_Configuration_Table;
	extern int old_graphs;
	extern int *NG_Index_Array;
	extern int NG_Index_Array_Count;
	extern NG_DIST Nongreedy_Distribution[];
	int i,j,k,m;
	int t_graphs;		
	int t_sum[SIZE_INTERVAL_ARRAY]; 
	int ng_sum[SIZE_INTERVAL_ARRAY]; 
	int step;				/* how many vertices make  */
						/* up 1% of the vertices   */
						/* (assume >=100 verts.)   */
	double r;
	double d_i_total;			/* sum of d(i) values over */
						/* an interval representing*/
						/* 1% of the placements.   */
	NG_DISTPTR dptr;

	for (i=0; i<SIZE_INTERVAL_ARRAY; i++) {
		t_sum[i] = 0; 
		ng_sum[i] = 0; 
	}
	/*******************************************************************/
	/** for this code to work, V must be a multiple of 100		  **/
	/*******************************************************************/
	t_graphs = num_graphs + old_graphs;
	fprintf(Sng_Distfile,"%d \n",t_graphs);
	/*for (i=0; i<num_v; i++)*/ /* assume num same for all G */
	/*    fprintf(Sng_Distfile,"%d %d\n",i,Nongreedy_Distribution[i]);*/
	for (i=0; i<num_v; i++) {
		fprintf(Sng_Distfile, "%d ", i);
		for (m=0; m<SIZE_INTERVAL_ARRAY; m++) {
			fprintf(Sng_Distfile, " %d %d",  
			Nongreedy_Distribution[i].num_ng[m],
			Nongreedy_Distribution[i].tot[m]);
		}
		fprintf(Sng_Distfile, "\n");
	}
	if (Output_Configuration_Table) {
		fprintf(Sng_Distfile,"G/NG Configurations\n");
		fprintf(Sng_Distfile,"-------------------\n");
		fprintf(Sng_Distfile,"%d\n", NG_Index_Array_Count);
		for (i=0; i<NG_INDEX_SIZE; i++) {
		    if (NG_Index_Array[i]) {
		        fprintf(Sng_Distfile,"%-6o %-6d\n",
				i, NG_Index_Array[i]);
		    }
		}
	}
	step = (int) (num_v * 0.01);
	fprintf(Sng_Distfile,"LOOKUP_TABLE\n");
	fprintf(Sng_Distfile,"------------\n");
	if (step <= 0) fprintf(outfile,"Error: 100 must divide V\n"),exit(121);
	for (i=0, k=0; i<num_v; i=i+step, k=k+1) {
		d_i_total = 0.0;
		for (m=0; m<SIZE_INTERVAL_ARRAY; m++) {
			t_sum[m] = 0;
			ng_sum[m]= 0;
		}
		for (j=i; j<i+step; j++) {
 		        dptr = &Nongreedy_Distribution[j];
			for (m=0; m<SIZE_INTERVAL_ARRAY; m++) {
				t_sum[m] += dptr->tot[m];
				ng_sum[m]+= dptr->num_ng[m];
			}
		}
	        fprintf(Sng_Distfile,"%d ", k);
		for (m=0; m<SIZE_INTERVAL_ARRAY; m++) {
			r = (t_sum[m] > 0) ? (double)ng_sum[m] / (double)t_sum[m]
					   : 0.0;
	        	fprintf(Sng_Distfile,"%.6f ", r);
		}
	        fprintf(Sng_Distfile,"\n");
	}
	

	fflush(Sng_Distfile);
	rewind(Sng_Distfile);
}


/*************************************************************************/
/*************************************************************************/
/** The files  ng_up.<num>.<prob>(.G)? are of the following format:     **/ 
/**								        **/
/** <num_graphs_processed>						**/
/** <vertex_rank> <ng_up_g> <up_g> <ng_up_n> <up_n>			**/
/** ............  ......... ...... ......... ......			**/
/** LOOKUP_TABLE							**/
/** ____________							**/
/** <pct_verts_placed> <ave_greedy_pct> <ave_nongreedy_pct>		**/
/** .................. ................ ...................		**/
/**									**/
/** Where <ng_up_g> = the total number of nongreedy "up"neighbors of all**/
/** 			GREEDY verticies				**/
/**	  <ng_up_n> = the total number of nongreedy "up"neighbors of all**/
/**			NONGREEDY vertices				**/
/** And   <up_g> = the total number of "up"neighbors of all GREEDY      **/
/** 			verticies					**/
/**       <up_n> = the total number of "up"neighbors of all NONGREEDY   **/
/** 			verticies					**/
/** And   <ave_greedy_pct> is the average of  <ng_up_g> / <up_g> over a **/
/**			range of 1% of the vertices.                    **/
/**       <ave_nongreedy_pct> is the average of  <ng_up_n> / <up_n> over**/
/**			a range of 1% of the vertices.                  **/
/*************************************************************************/
/*************************************************************************/
FILE *read_ng_upfile()
{
	int i,j;
	int	old_times_ng,
		old_ng_up_g,
		old_up_g,
		old_ng_up_n,
		old_up_n;
	double	old_pct_ng_up_g,
		old_pct_ng_up_n;
	char fname[80], pr[10], *home;
	FILE *fp;
	UP_INFOPTR p;

	home=(char *)malloc(80);
	/*******************************************************************/
	/** for this code to work, V must be a multiple of 100		  **/
	/*******************************************************************/
	if (Geometric_Graphs)
		sprintf(pr, "%.3f.G", prob);
	else
		sprintf(pr, "%.3f", prob);
	home = getenv("HOME");
	sprintf(fname,"%s/research/distributions/ng_up_pct/ng_up.%d.%s",home,num,pr+2);
	/* printf("ENTER NAME OF NG UPFILE: ");*/
	/*scanf("%s",fname);*/
	if ((fp = fopen(fname, "r+")) != NULL) {
		fscanf(fp, "%d", &old_graphs);
		for (i=0; i<num; i++) {
			p = &NG_Up_Array[i];
			fscanf(fp, "%d %d %d %d %d %lf %lf %d", &j, 
				&old_ng_up_g,
				&old_up_g,
				&old_ng_up_n,
				&old_up_n,
				&old_pct_ng_up_g,
				&old_pct_ng_up_n,
				&old_times_ng);
			p->times_ng += old_times_ng;
			p->ng_up_g += old_ng_up_g;
			p->up_g    += old_up_g;
			p->ng_up_n += old_ng_up_n;
			p->up_n    += old_up_n;
			p->pct_ng_up_g += old_pct_ng_up_g;
			p->pct_ng_up_n += old_pct_ng_up_n;
		}
		/*fflush(fp);*/
	} else {
		if ((fp = fopen(fname, "w")) == NULL) 
			fprintf(outfile, "Error in ng_upfile\n"), exit(24);
	}
	rewind(fp);
	return(fp);
}

void write_ng_upfile(int num_v)
/******************************************************************************/
/** write_ng_upfile()							     **/
/******************************************************************************/
{
	extern FILE *NG_Upfile;
	extern int old_graphs;
	int i,j,k;
	int	t_ng_n,
		t_n,
		t_ng_g,
		t_g,
		times_gr;
	int t_graphs;		
	int step;				/* how many vertices make  */
						/* up 1% of the vertices   */
						/* (assume >=100 verts.)   */
	double t_times_ng, 
	      tg, tn, ttg, ttn;
	double ave_pct_g,	/* ave % greedy for one gr. placement */
	      ave_pct_n,	/* ave % greedy for one ng. placement */
				/* (these later hold ultimate ave. of */
				/*  percentiles)		      */
	      tot_ave_pct_g,	/* total of above for one percentile  */
	      tot_ave_pct_n;
	UP_INFOPTR p;

	/*******************************************************************/
	/** for this code to work, V must be a multiple of 100		  **/
	/*******************************************************************/
	t_graphs = num_graphs + old_graphs;
	fprintf(NG_Upfile,"%d \n",t_graphs);
	for (i=0; i<num_v; i++) {  /* assume num same for all G */
	    p = &NG_Up_Array[i];
	    fprintf(NG_Upfile,"%d %d %d %d %d %.6f %.6f %d\n",i,
			p->ng_up_g, p->up_g, p->ng_up_n, p->up_n, 
			p->pct_ng_up_g, p->pct_ng_up_n, p->times_ng);
	}
	step = (int) (num_v * 0.01);
	fprintf(NG_Upfile,"LOOKUP_TABLE\n");
	fprintf(NG_Upfile,"------------\n");
	if (step <= 0) fprintf(outfile,"Error: 100 must divide V\n"),exit(120);
	for (i=0, k=0; i<num_v; i=i+step, k=k+1) {
		t_ng_n = t_ng_g = t_n = t_g = 0;
		tot_ave_pct_g = tot_ave_pct_n = 0.0;
		t_times_ng = 0.0;
		for (j=i; j<i+step; j++) {
			p = &NG_Up_Array[j];
			times_gr = t_graphs - p->times_ng;
			ave_pct_g = (times_gr>0) ? p->pct_ng_up_g / times_gr
						 : 0.0;
			ave_pct_n = (p->times_ng>0) ? p->pct_ng_up_n/p->times_ng
						 : 0.0;
			tot_ave_pct_g += ave_pct_g;
			tot_ave_pct_n += ave_pct_n;
			t_ng_n += p->ng_up_n; 
			t_n    += p->up_n;
			t_ng_g += p->ng_up_g; 
			t_g    += p->up_g;
			t_times_ng+= (double) p->times_ng;
		}
		ave_pct_g = tot_ave_pct_g / (double) step;
		ave_pct_n = tot_ave_pct_n / (double) step;
		t_times_ng  = t_times_ng / (double) step;
		tg = (t_g > 0) ? (double) t_ng_g / (double)t_g : 0.0;
		tn = (t_n > 0) ? (double) t_ng_n / (double)t_n : 0.0;
		ttn= (t_times_ng > 0.0)?((double)t_ng_n/(double)step) / 
					 (double)t_times_ng
				       : 0.0;
		ttg= (t_graphs-t_times_ng > 0.0)? ((double)t_ng_g / step) / 
						(double)(t_graphs-t_times_ng) 
					      : 0.0;
	        fprintf(NG_Upfile,"%d %.6f %.6f %.6f %.6f %.6f\n", k, tg, tn, 
				ave_pct_g, ave_pct_n, ttn);
	}
	fflush(NG_Upfile);
	rewind(NG_Upfile);
}
