/****************************************************************************/
/********** queue.c *********************************************************/
/****************************************************************************/
#include <stdio.h> 
#include "stdlib.h" 
#include "queue.h" 

int    printf(const char*, ...);

Q_TYPPTR get_q()
{
	Q_TYPPTR q = (Q_TYPPTR) malloc(sizeof(Q_TYP));

	q->head = (Q_ELEMPTR) malloc(sizeof(Q_ELEM));
	q->tail = q->head;
	q->head->next = NULL;
	return(q);
}

Q_ELEMPTR get_q_element(int v)	/* not so concerned with malloc */
				/* efficiency now 		*/
{
	Q_ELEMPTR qtemp = (Q_ELEMPTR) malloc(sizeof(Q_ELEM));

	qtemp->v = v;
	return(qtemp);
}



void enqueue(int v, Q_TYPPTR q)
{
	Q_ELEMPTR new_entry = get_q_element(v);

	new_entry->next = NULL;
	q->tail->next = new_entry;
	q->tail = new_entry;
}



int dequeue(Q_TYPPTR q)
{
	int v;
	Q_ELEMPTR qtemp;

	qtemp = q->head->next;  /* skip dummy element */
	if (qtemp == NULL) 
		return(EMPTY);
	v = qtemp->v;       /* remember dequeued process id */
	q->head->next = qtemp->next;
	if (qtemp->next == NULL)
		q->tail = q->head;
	free((char *) qtemp);
	return(v);
}

void print_queue(Q_TYPPTR q)
{
	Q_ELEMPTR qtemp;

	if (!q->head->next)  return;
	printf("****************************************************\n");
	printf("****************************************************\n");
	printf("****************************************************\n");
	for (qtemp= q->head->next; qtemp; qtemp = qtemp->next) 
		printf("%d ", qtemp->v);
	printf("\n****************************************************\n");
}

void free_queue(Q_TYPPTR q)
{
	int c;

	while ((c = dequeue(q)) != EMPTY) ;
	free((char *) q->head->next);
	free((char *) q);
}
