/***************************************************************************/
/****************************** SNG_DIST.C *********************************/
/***************************************************************************/
#include "part.h"

extern int num;
extern int N_Interval;

extern int 
    hold_ng_cost[2][MAX_VERTS],     /* cost in ng upneighbors          */
    hold_node_cost[2][MAX_VERTICES],   /* keep track of best partitioning */
    hold_vertices[MAX_VERTICES],
    hold_post_tots[MAX_VERTICES];


extern int N_Prob;		/* NG_Up_Results is discrete, divided      */
				/* into rows of different edge prob. find  */
				/* out which of these is closest to prob   */


extern NG_DIST Nongreedy_Distribution[MAX_VERTS];  
				/* ND[i] = #graphs.w/i sng  */


extern PCT_NG_UP (*NG_Up_Results)[NG_UP_SIZE];	/* gives ng up percentages  */
						/* from ng_uptab.c          */


void update_dists_k_over_total(int j)
{
	int v, k;
        int pctile;     /* percentile ex. 500 vert--> v50 is 10th pctile */
        int ng_up, total_up;            /* #ng upneighbors, total upn.   */

	double  step,                           /* used in finding the  */
                start,                          /* mult. NG_Dist's based*/
                current_ng_pct;                 /* non ng up-percentage */

	/************************11/92 - 12/92******************/
	v = hold_vertices[j];
	pctile = j / N_Interval;    /* note - 100 must divide num */
	
	step = (NG_Up_Results[N_Prob][pctile].gr_pct - 
	NG_Up_Results[N_Prob][pctile].ng_pct) / (double) NUM_INTERVALS;
	start = NG_Up_Results[N_Prob][pctile].ng_pct;
	ng_up =    hold_ng_cost[SET_A][v]+ hold_ng_cost[SET_B][v];
	total_up = hold_node_cost[SET_A][v]+ hold_node_cost[SET_B][v];
	current_ng_pct = (total_up > 0) ? (double) ng_up / (double) total_up
					    : 0.0;

	Nongreedy_Distribution[j].tot[SIZE_INTERVAL_ARRAY-1]++;
	for (k=0; k<NUM_INTERVALS; k++) {
		if (in_interval(current_ng_pct, start, step, k)) {
			Nongreedy_Distribution[j].tot[k]++;
			break;
		}
		if (k == (NUM_INTERVALS - 1))
			Nongreedy_Distribution[j].tot[k]++;
		}
	if (hold_post_tots[j] < 0) {
		Nongreedy_Distribution[j].num_ng[SIZE_INTERVAL_ARRAY-1]++;
		for (k=0; k<NUM_INTERVALS; k++) {
			if (in_interval(current_ng_pct, start, step, k)) {
				Nongreedy_Distribution[j].num_ng[k]++;
				break;
			}
			if (k == (NUM_INTERVALS-1)) 
				Nongreedy_Distribution[j].num_ng[k]++;
		}
	}
}

void update_dists_k(int j)
{
	int v, k;
        int ng_up;            /* #ng upneighbors */

	v = hold_vertices[j];
	
	ng_up =    hold_ng_cost[SET_A][v]+ hold_ng_cost[SET_B][v];

	Nongreedy_Distribution[j].tot[SIZE_INTERVAL_ARRAY-1]++;
	for (k=0; k<NUM_INTERVALS; k++) {
		if (ng_up == k) 
			Nongreedy_Distribution[j].tot[k]++;
	}
	if (hold_post_tots[j] < 0) {
		Nongreedy_Distribution[j].num_ng[SIZE_INTERVAL_ARRAY-1]++;
		for (k=0; k<NUM_INTERVALS; k++) {
			if (ng_up == k) 
				Nongreedy_Distribution[j].num_ng[k]++;
		}
	}
}

void update_dists_abs(int j)
{
	int v, k;
        int abs_diff;            /* #ng upneighbors */

	v = hold_vertices[j];
	
	abs_diff =    ABS(hold_node_cost[SET_A][v] - hold_node_cost[SET_B][v]);

	Nongreedy_Distribution[j].tot[SIZE_INTERVAL_ARRAY-1]++;
	for (k=0; k<NUM_INTERVALS; k++) {
		if (abs_diff == k) 
			Nongreedy_Distribution[j].tot[k]++;
	}
	if (hold_post_tots[j] < 0) {
		Nongreedy_Distribution[j].num_ng[SIZE_INTERVAL_ARRAY-1]++;
		for (k=0; k<NUM_INTERVALS; k++) {
			if (abs_diff == k) 
				Nongreedy_Distribution[j].num_ng[k]++;
		}
	}
}

void update_dists_ng_10(int j)
{
	int v, k;
        extern int Num_NG_In_First_10;

	v = hold_vertices[j];
	
	Nongreedy_Distribution[j].tot[SIZE_INTERVAL_ARRAY-1]++;
	for (k=0; k<NUM_INTERVALS; k++) {
		if (Num_NG_In_First_10 == k) 
			Nongreedy_Distribution[j].tot[k]++;
	}
	if (hold_post_tots[j] < 0) {
		Nongreedy_Distribution[j].num_ng[SIZE_INTERVAL_ARRAY-1]++;
		for (k=0; k<NUM_INTERVALS; k++) {
			if (Num_NG_In_First_10 == k) 
				Nongreedy_Distribution[j].num_ng[k]++;
		}
	}
}
